//-- AppVersion ----------------------------------------------------------------
//
//  ATTLFilter
//
//  Copyright  2006 Alexander Kamburov
//  wise_guybg@yahoo.com
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//------------------------------------------------------------------------------
unit AppVersion;

interface

type
  TAppInfo = record
    Version: string;
    Name: string;
    Copyright: string;
  end;

function GetAppInfo: TAppInfo;

implementation

uses
  Windows, SysUtils, Forms;

function GetAppInfo: TAppInfo;
var
  AppFileName: PAnsiChar;
  VerBufSize, InfoBufSize, TempBufSize: LongWord;
  iTemp: Integer;
  Handle: THandle;
  VerBuffer, InfoBuffer, TempBuffer: Pointer;
  strLang: string;

  function GetStringValue(const AValue: string): string;
  begin
    VerQueryValue(VerBuffer,
      PAnsiChar(Format('\StringFileInfo\%s\%s', [strLang, AValue])),
      TempBuffer, TempBufSize);
    if InfoBufSize > 0 then
    begin
      SetLength(Result, StrLen(PAnsiChar(TempBuffer)));
      Result := PAnsiChar(TempBuffer);
    end
      else Result := 'n/a';
  end;

begin
  AppFileName := Pointer(Application.ExeName);
  VerBufSize := GetFileVersionInfoSize(AppFileName, Handle);
  if VerBufSize > 0 then
  begin
    VerBuffer := AllocMem(VerBufSize);
    try
      if GetFileVersionInfo(AppFileName, 0, VerBufSize, VerBuffer) then
        if VerQueryValue(VerBuffer,
             '\VarFileInfo\Translation',
             InfoBuffer, InfoBufSize) then
          if InfoBufSize >= 4 then
          begin
            iTemp := 0;
            StrLCopy(@iTemp, PAnsiChar(InfoBuffer), 2);
            strLang := IntToHex(iTemp, 4);
            StrLCopy(@iTemp, PAnsiChar(InfoBuffer) + 2, 2);
            strLang := strLang + IntToHex(iTemp, 4);

            //you can add other properties to be read
            Result.Version := GetStringValue('FileVersion');
            Result.Name := GetStringValue('ProductName');
            Result.Copyright := GetStringValue('LegalCopyright');
          end;
    finally
      FreeMem(VerBuffer, VerBufSize);
    end;
  end;
end;//GetAppInfo

end.

